'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _robox = require('robox');

var _robox2 = _interopRequireDefault(_robox);

var _getMatches = require('./get-matches');

var _getMatches2 = _interopRequireDefault(_getMatches);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Reflex = function Reflex(Comp) {
  var Base = (0, _robox2.default)(Comp);

  var ReflexWrap = function (_React$Component) {
    _inherits(ReflexWrap, _React$Component);

    function ReflexWrap() {
      _classCallCheck(this, ReflexWrap);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReflexWrap).call(this));

      _this.state = {
        matches: []
      };
      _this.match = _this.match.bind(_this);
      return _this;
    }

    _createClass(ReflexWrap, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.match();
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps() {
        this.match();
      }
    }, {
      key: 'match',
      value: function match() {
        var _ref = this.context.reflexbox || {};

        var breakpoints = _ref.breakpoints;

        var matches = (0, _getMatches2.default)(breakpoints);
        this.setState({ matches: matches });
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _ref2 = this.context.reflexbox || _config2.default;

        var breakpoints = _ref2.breakpoints;
        var matches = this.state.matches;
        var _props = this.props;
        var col = _props.col;

        var props = _objectWithoutProperties(_props, ['col']);

        Object.keys(breakpoints).forEach(function (key) {
          delete props[key];
        });

        var currentCol = matches.reduce(function (a, b) {
          return _this2.props[b] || a;
        }, col || null);

        // Map legacy props
        if (props.column) {
          props.flexColumn = props.column;
          delete props.column;
        }

        if (props.auto) {
          props.flexAuto = props.auto;
          delete props.auto;
        }

        return _react2.default.createElement(Base, _extends({}, props, { col: currentCol }));
      }
    }]);

    return ReflexWrap;
  }(_react2.default.Component);

  ReflexWrap.contextTypes = {
    reflexbox: _react2.default.PropTypes.shape({
      breakpoints: _react2.default.PropTypes.object
    })
  };

  ReflexWrap.propTypes = {
    flex: _react2.default.PropTypes.bool,
    wrap: _react2.default.PropTypes.bool,
    flexColumn: _react2.default.PropTypes.bool,
    column: _react2.default.PropTypes.bool,
    align: _react2.default.PropTypes.oneOf(['stretch', 'center', 'baseline', 'flex-start', 'flex-end']),
    justify: _react2.default.PropTypes.oneOf(['center', 'space-around', 'space-between', 'flex-start', 'flex-end']),
    flexAuto: _react2.default.PropTypes.bool,
    auto: _react2.default.PropTypes.bool,
    flexNone: _react2.default.PropTypes.bool,
    order: _react2.default.PropTypes.number,
    col: _react2.default.PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    sm: _react2.default.PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    md: _react2.default.PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    lg: _react2.default.PropTypes.oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]),
    is: function is(props, propName, componentName) {
      if (props[propName]) {
        return new Error('Warning! Deprecated prop `' + propName + '` supplied to' + ' `' + componentName + '`. Use the Reflex higher order component instead. https://github.com/jxnblk/reflexbox/');
      }
    }
  };

  return ReflexWrap;
};

exports.default = Reflex;